unit HTMLgenUnit;

interface

uses
  Windows, SysUtils, Classes, Controls, Forms, Dialogs, ComCtrls, StdCtrls, ActnList,
  ImgList, Buttons, IniFiles, Placemnt, ExtCtrls, RXCombos, ToolEdit, Mask, ShellAPI, 
  UCustomini, UHighLighter, UGenDeclarations, UConvertClass;

type


  THTMLform = class(TForm)
    OpenDia: TOpenDialog;
    SaveDia: TSaveDialog;
    ColorDia: TColorDialog;
    PageControl: TPageControl;
    ConvertSheet: TTabSheet;
    ConfigSheet: TTabSheet;
    ColorProfileSheet: TTabSheet;
    FormImages: TImageList;
    ActionList: TActionList;
    lblSourcefiles: TLabel;
    btnRemove: TBitBtn;
    BtnAdd: TBitBtn;
    StatusBar: TStatusBar;
    ProgressGroup: TGroupBox;
    ProgCurr: TProgressBar;
    ProgTotal: TProgressBar;
    lblcurrProgress: TLabel;
    lblTotProgress: TLabel;
    BtnConvert: TBitBtn;
    ActAddToList: TAction;
    ActRemoveFromList: TAction;
    ActConvert: TAction;
    SrcFilesList: TListView;
    HighlightOptSheet: TTabSheet;
    lblNames: TLabel;
    NameEdit: TEdit;
    lnlEditNameText: TLabel;
    BtnAddName: TBitBtn;
    BtnRemoveName: TBitBtn;
    ColorGroup: TGroupBox;
    highColBev: TBevel;
    ShowNameCol: TLabel;
    BtnCustom: TBitBtn;
    NamesList: TListBox;
    ColorCombo: TColorComboBox;
    HTMLColGroup: TGroupBox;
    ShowBackCol: TLabel;
    BackBev: TBevel;
    TextBev: TBevel;
    LinkBev: TBevel;
    visLinkBev: TBevel;
    ShowVisLinkCol: TLabel;
    ShowLinkCol: TLabel;
    ShowTextCol: TLabel;
    lblBackCol: TLabel;
    lbltextCol: TLabel;
    lblLinkCol: TLabel;
    lblVisLinkcol: TLabel;
    HTMLIMGGroup: TGroupBox;
    RelImgCheck: TCheckBox;
    BackImageEdit: TFilenameEdit;
    lblImgFile: TLabel;
    TitleEdit: TEdit;
    lblTitle: TLabel;
    lblAuth: TLabel;
    AuthEdit: TEdit;
    BtnBackCol: TBitBtn;
    BtnTextCol: TBitBtn;
    BtnLinkCol: TBitBtn;
    BtnVisLinkcol: TBitBtn;
    AppOptsGroup: TGroupBox;
    ProfileListCombo: TComboBox;
    HTMLGenGroup: TGroupBox;
    lblCurrProfile: TLabel;
    INIDefsCheck: TCheckBox;
    InputDirEdit: TDirectoryEdit;
    lblInDir: TLabel;
    lblImgDir: TLabel;
    DestDirEdit: TDirectoryEdit;
    lblDestDir: TLabel;
    DestImgEdit: TDirectoryEdit;
    IOOptsGroup: TGroupBox;
    PromptOnOverwCheck: TCheckBox;
    SkipExistingCheck: TCheckBox;
    ActPickCol: TAction;
    ActAddName: TAction;
    ActRemoveName: TAction;
    BtnSaveOpts: TBitBtn;
    ActSaveOpts: TAction;
    ActAbout: TAction;
    BtnUpdate: TBitBtn;
    ActUpdateName: TAction;
    lblNameImg: TLabel;
    NameImgEdit: TFilenameEdit;
    BtnGroup: TGroupBox;
    BtnAbout: TBitBtn;
    btnExit: TBitBtn;
    CaseSensCheck: TCheckBox;
    BtnLoadProfile: TBitBtn;
    ActOpenProfile: TAction;
    BrokenLinesCheck: TCheckBox;
    CustHtmlGroup: TGroupBox;
    CustFrontHTMLMemo: TMemo;
    CustEndHTMLMemo: TMemo;
    BitBtn1: TBitBtn;
    ActSaveNewOpts: TAction;
    ActStopConvert: TAction;
    FormPlacement: TFormStorage;
    BtnClearMRU: TButton;
    ActClearMRU: TAction;
    FrontPageHTMLMemo: TMemo;
    EndPageHTMLMemo: TMemo;
    HelpBtn: TBitBtn;
    // general initialization and config loading
    procedure FormCreate(Sender: TObject);
    // freeing of created objects and save configs if needed
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    // add a file to be converted to the list
    procedure ActAddToListExecute(Sender: TObject);
    // remove a file to be converted to the list
    procedure ActRemoveFromListExecute(Sender: TObject);
    // start converting files to HTMl
    procedure ActConvertExecute(Sender: TObject);
    // interrupt conversion
    procedure ActStopConvertExecute(Sender: TObject);
    // show about dialog
    procedure ActAboutExecute(Sender: TObject);
    // add a name to be highlighted to the list
    procedure ActAddNameExecute(Sender: TObject);
    // remove a name to be highlighted to the list
    procedure ActRemoveNameExecute(Sender: TObject);
    // update the selected name in the list
    procedure ActUpdateNameExecute(Sender: TObject);
    // change one of the color attributes (based on the sender object)
    procedure ActPickColExecute(Sender: TObject);
    // save options to the currently open config file
    procedure ActSaveOptsExecute(Sender: TObject);
    // open a new profile
    procedure ActOpenProfileExecute(Sender: TObject);
    // saves the currently loaded configuration under a new file name
    procedure ActSaveNewOptsExecute(Sender: TObject);
    // update the remove button
    procedure SrcFilesListMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    // update the remove button
    procedure SrcFilesListKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    // update the remove button
    procedure SrcFilesListSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    // update remove/update buttons
    procedure NamesListClick(Sender: TObject);
    // update remove/update buttons
    procedure NamesListKeyPress(Sender: TObject; var Key: Char);
    // only add non-empty names (length checking)
    procedure NameEditChange(Sender: TObject);
    // update name highlight color
    procedure ColorComboChange(Sender: TObject);
    // update the name color attribute
    procedure ColorComboKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    // notifies that the loaded (memory) config is out of sync with the one on disk
    procedure OptionsChanged(Sender: TObject);
    // Sync UI controls with the in-memory objects for the HTML options page
    procedure HTMLPageCTRLExit(Sender: TObject);
    // Sync UI controls with the in-memory objects for the Configuration page
    procedure ConfigPageCTRLExit(Sender: TObject);
    // Clear the Most Recently Used list
    procedure ActClearMRUExecute(Sender: TObject);
    procedure HelpBtnClick(Sender: TObject);
  private
    NeedUpdating: Boolean;
    // Update Action Wrapper
    UpdateClass: TSettingsAction;
    // container object for (almost) all options
    OpenProfile: THighlightProfile;
    // container for options not stored in the cfg file and Ini wrapper
    CustomIni: TcustomIni;
    // functional class that does the actual conversion to HTML
    Converter: TConvertClass;
    // Creates and sets up the profile Object // connects it to the UI controls
    procedure CreateAndInitProfile;
    // updates the memory object for source files
    procedure SrcFilesListChange;
    // update memory objects from the UI controls in the HTML options page
    procedure UpdateFromHTMLPage;
    // update memory objects from the UI controls in the configuration page
    procedure UpdateFromConfigPage;
    // tries to load the pecified configuration file
    function OpenCfgFile(const filename, oldFile: string): boolean;
    // checks to see if the specified profile can be loaded and tries loads it
    procedure CheckForNewProfile(const ProfileName: string);
    // update the source files page only
    function PromptSave: boolean;
    { Private declarations }
  public
    procedure appIdle(Sender: TObject; var Done: Boolean); // status displaying
    procedure appHint(Sender: TObject); // Show hints on the statusbar
    { Public declarations }
  end;

var
  HTMLform: THTMLform;
  (********************************************************************************************)
implementation

uses UAbout;

{$R *.DFM}
(**********************************************************************************************)

procedure THTMLForm.appIdle(Sender: TObject; var Done: Boolean);
begin
  if sender is TApplication then        // status bar messages
    Statusbar.Panels[2].text := DefOpStatus;
end;

(**********************************************************************************************)

procedure THTMLForm.appHint(Sender: TObject);
begin
  Statusbar.Panels[0].text := (Sender as Tapplication).Hint; // display hints on the statusbar
end;
(**********************************************************************************************)

procedure THTMLform.FormCreate(Sender: TObject);
begin
  try
    // create the Updater action
    UpdateClass := TSettingsAction.create(ActSaveOpts);
    // Create the ini file wrapper
    CustomIni := TCustomIni.create(extractfilepath(application.exename) +
      changefileext(extractfilename(Application.ExeName), '') + '.ini', UpdateClass);
    // assign the combo box to the object to keep up ith the profile MRU list
    Converter := TConvertClass.Create(UpdateClass); // create the converter object
    // create the profile object and initialize the UI component links
    CreateAndinitProfile;
    FormPlacement.IniFilename := Customini.filename; // use same ini file for form placement

    CustomIni.ReadIniValues;            // read profile list from ini file

    if not OpenCfgFile(customIni.CurrProfileName, '') then // try to open the most recent
      raise EGenException.Create('');   // profile;if not possible, raise an exception

    ProfileListCombo.ItemIndex := 0;
    PageControl.ActivePage := PageControl.Pages[0];
    activecontrol := BtnAdd;
    application.OnIdle := AppIdle;      // Assign the iddle event to TApplication
    application.OnHint := AppHint;      // Set the hint delays to 0
    application.HintHidePause := 2000;  // to display the hints instantly
    application.HintPause := 0;         // on the statusbar.
    application.HintShortPause := 0;
    NeedUpdating := False;
  except
    // a profile (config) file must be loaded for the app to operate correctly
    application.messagebox('Error loading configuration file.' + #13
      + 'Delete the Corrupted file and try again.', 'Fatal Error', mb_iconstop);
    Close();                            // call close to free any created objects
    application.terminate;              // and shut down
  end;
end;
(**********************************************************************************************)

procedure THTMLform.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if BtnEXit.Enabled then               // if we are not converting files
    begin
      if NeedUpdating then
        begin
          OpenProfile.IOOptions.UpdateFromUI;
          OpenProfile.AppOptions.UpdateFromUI;
          OpenProfile.PageOptions.UpdateFromUI;
        end;
      if assigned(Converter) then       // free the ocnverter object first
        Converter.free;                 // since it has to access other objects
      if assigned(OpenProfile) then     // Close the profile object
        begin
          if assigned(UpdateClass) then // and save any changes if the user
            if UpdateClass.SettingsChanged then // wants to.
              PromptSave;
          OpenProfile.free;
        end;
      if assigned(UpdateClass) then     // free the Updater object
        UpdateClass.Free;
      if assigned(CustomIni) then       // free the Ini wrapper object
        begin
          CustomIni.SaveIniValues;
          CustomIni.Free;
        end;
      action := cafree;                 // free the form itself in the end
    end
  else
    Action := caNone;                   // if we are converting, don't quit
end;                                    // conversion must be stooped before exiting
(**********************************************************************************************)

procedure THTMLForm.CreateAndInitProfile;
begin
  OpenProfile := THighLightProfile.create(UpdateClass); // create the profile container
  // assign the form controls to the in-memory objects
  OpenProfile.assignControls(
    NamesList,
    SrcFilesList,
    NameEdit, TitleEdit, AuthEdit, BackImageEdit,
    NameImgEdit, ShowNameCol, ShowBackCol, ShowTextCol, ShowLinkCol, ShowVisLinkCol,
    ActRemoveFromList, ActConvert, ActRemoveName, ActUpdateName,
    InputDirEdit, DestDirEdit, DestImgEdit,
    RelImgCheck, BrokenLinesCheck, CaseSensCheck, PromptOnOverwCheck, SkipExistingCheck,
    FrontPageHTMLMemo, EndPageHTMLMemo, CustFrontHTMLMemo, CustEndHTMLMemo);

  // assign the profile objects to the Converter class
  with openprofile do
    Converter.AssignOptionObjects(PageOptions, AppOptions, NameList, IOOptions);
  // assign the form controls updated by the Converter class
  Converter.AssignControls(ProgTotal, ProgCurr, SrcFilesList);
  // assign the form controls updated by the Ini file wrapper object
  CustomIni.assignControls(ProfileListcombo, IniDefsCheck);
end;
(**********************************************************************************************)

function THTMLForm.OpenCfgFile(const fileName, OldFile: string): boolean;
{-----------------------}
  function createDefaultFile(const defFileName: string): Boolean;
  begin
    Application.MessageBox('Creating a new file with default values',
      'Configuration file not found', mb_iconasterisk);
    result := OpenProfile.SaveToFile(DefFileName); // if file doesn't exist, write default
  end;                                  // configuration data under the filename
{-----------------------}
var
  tempFile: PChar;
  tempNewFile: string;
begin
  tempNewFile := FileName;
  tempFile := stralloc(maxpathlength);
  if not FileExists(OldFile) then
    begin
      gettempfilename(PChar(extractfilepath(Application.exename)),
        pchar('T2H'), 0000, tempFile);
      DeleteFile(tempFile);
      tempNewFile := ChangeFileExt(string(tempFile), '.cfg');
    end;
  if FileName = OldFile then            // skip if trying to load the same profile
    begin
      result := true;
      exit
    end;
  if UpdateClass.SettingsChanged then   // ask to save any changes if needed
    PromptSave;
  OpenProfile.free;                     // free and recreate to the profile object
  createAndinitProfile;                 // assigning the apropriate UI controls
  if FileExists(filename) then          // try to open specified file
    begin
      if OpenProfile.LoadFromFile(filename) then // and try to read config data from it
        Result := true
      else if FileExists(oldFile) then
        Result := OpenProfile.LoadFromFile(OldFile) // if failed, re-read old file
      else
        begin
          Result := createDefaultFile(tempNewFile);
          if Result then
            CustomIni.CurrProfileName := tempNewFile;
        end;
    end
  else
    Result := createDefaultFile(FileName);
  if not assigned(Converter) then
    converter := TConvertClass.create;  // initialize the converter object
  OpenProfile.PageOptions.UpdateControls;
  Updateclass.SettingsChanged := false; // indicate no changes
end;
(**********************************************************************************************)

function THTMLForm.PromptSave: boolean;
begin                                   // prompt to save changes made to the config
  result := false;                      // return false if changes were not saved
  if application.messagebox('Do you want to save the changes ?',
    'Configuration changed', mb_iconquestion or mb_yesno) = idYes then
    ActSaveOpts.Execute
  else
    result := false;
end;
(**********************************************************************************************)

procedure THTMLForm.UpdateFromHTMLPage; // update memory objects from the UI controls
begin                                   // in the HTML options page
  if UpdateClass.SettingsChanged then
    with Openprofile do
      begin
        PageOptions.UpdateFromUI;
        if CustomIni.UsesIniDefaults then // use current constants (for new files)
          begin
            DefBackground := ShowBackCol.Color;
            DefText := ShowTextCol.Color;
            DefLink := ShowLinkCol.Color;
            DefVisitedLink := ShowVisLinkCol.Color;
          end
        else                            // use built in constants
          begin
            DefBackground := DefBackgroundConst;
            DefText := DefTextConst;
            DefLink := DefLinkConst;
            DefVisitedLink := DefVisitedLinkConst;
          end;
        NeedUpdating := False;
      end;
end;
(**********************************************************************************************)

procedure THTMLForm.UpdateFromConfigPage; // update memory objects from the UI controls
begin                                   // in the general options page
  if UpdateClass.SettingsChanged then
    with OpenProfile do
      begin
        AppOptions.UpdateFromUI;
        CustomIni.UsesIniDefaults := iniDefsCheck.Checked;
        IOOptions.UpdateFromUI;
        NeedUpdating := False;
      end;
end;
(**********************************************************************************************)

procedure THTMLform.SrcFilesListChange; // the source files list has been changed
begin
  // enable processing if there are any input files
  ActConvert.enabled := srcFilesList.Items.Count > 0;
  with SrcFilesList do                  // disable removes if nothing is selected
    ActRemoveFromList.enabled := (items.count > 0) and (selcount > 0);
end;
(**********************************************************************************************)

procedure THTMLform.SrcFilesListMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin                                   // indicate changes on input from the user
  SrcFilesListChange;
end;
(**********************************************************************************************)

procedure THTMLform.SrcFilesListKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);                  // indicate changes on input from the user
begin
  SrcFilesListChange;
end;
(**********************************************************************************************)

procedure THTMLform.SrcFilesListSelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);  // disable removes if nothing is selected
begin
  ActRemoveFromList.enabled := selected;
end;
(**********************************************************************************************)

procedure THTMLform.NamesListClick(Sender: TObject);
begin                                   // signal changes on user input
  OpenProfile.NamesListChange;
end;
(**********************************************************************************************)

procedure THTMLform.NamesListKeyPress(Sender: TObject; var Key: Char);
begin                                   // signal changes on user input
  OpenProfile.NamesListChange;
end;
(**********************************************************************************************)

procedure THTMLform.ColorComboChange(Sender: TObject);
begin                                   // easy color picker
  ShowNameCol.Color := Colorcombo.ColorValue;
end;
(**********************************************************************************************)

procedure THTMLform.ColorComboKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin                                   // update the Name color attribute
  ColorComboChange(Sender);
end;
(*********************************************************************************************)

procedure THTMLform.NameEditChange(Sender: TObject);
begin                                   // can only add nonempty names
  ActAddName.Enabled := length(NameEdit.text) > 0
end;
(*********************************************************************************************)

procedure THTMLForm.CheckForNewProfile(const ProfileName: string);
begin                                   // try to load specified profile
  if UpdateClass.SettingsChanged then   // If changes have taken place
    promptSave;                         // prompt the user to save them.
  if OpenCFGFile(ProfileName, Customini.CurrProfileName) then // try to open specified profile
    CustomIni.CurrProfileName := ProfileName; // update current profile name (in the MRU)
end;
(*********************************************************************************************)

procedure THTMLform.OptionsChanged(Sender: TObject);
begin                                   // one of the input controls has changed
  if (sender is TCustomCombobox) then   // if it's the profiles combo
    begin                               // handle it separately
      if TComboBox(Sender).name = 'ProfileListCombo' then
        CheckForNewProfile(TCombobox(Sender).text);
    end
  else
    begin
      NeedUpdating := True;
      UpdateClass.SettingsChanged := true; // signal changes
      if (sender is TCustomCheckBox) then
        PromptOnOverwCheck.Enabled := not SkipExistingCheck.Checked;
    end;
end;
(*********************************************************************************************)

procedure THTMLform.HTMLPageCTRLExit(Sender: TObject); // update the HTML options from the
begin                                   // HTML page controls
  UpdateFromHTMLPage;
end;
(*********************************************************************************************)

procedure THTMLform.ConfigPageCTRLExit(Sender: TObject); // update the configuration from the
begin                                   // configuration page controls
  UpdateFromConfigPage;
end;
(*********************************************************************************************)

procedure THTMLform.ActAddToListExecute(Sender: TObject);
begin                                   // add an dump file to the source files list
  Opendia.InitialDir := OpenProfile.IOOptions.DefaultInputDir; // initialize the openDialog
  if OpenProfile.IOOptions.InputFiles.Count > 0 then
    OpenDia.Filename := OpenProfile.IOOptions.getcurrentFile;
  OpenDia.DefaultExt := CustomIni.DefaultExt;
  OpenDia.Filter := 'Text files|*.txt;*.dmp;*.dump|All files|*.*';
  OpenDia.Options := OpenDia.Options + [ofAllowMultiSelect, ofFileMustExist];
  if Opendia.execute then
    begin
      Statusbar.Panels[2].text := 'Opening files'; // display status
      // add the newly selected files to the input file list
      OpenProfile.IOOptions.addFiles(Opendia.Files);
    end;
end;
(**********************************************************************************************)

procedure THTMLform.ActAddNameExecute(Sender: TObject);
begin                                   // add a new name for highlighting
  OpenProfile.AddName(NameEdit.Text, NameImgEdit.Text, CustFrontHTMLMemo.Text,
    CustEndHTMLMemo.Text, ShowNameCol.Color);
end;
(**********************************************************************************************)

procedure THTMLform.ActRemoveNameExecute(Sender: TObject);
begin                                   // remove the selected name from the name list
  OpenProfile.DeleteName(NamesList.ItemIndex);
end;
(**********************************************************************************************)

procedure THTMLform.ActUpdateNameExecute(Sender: TObject);
begin                                   // update an existing name with new attributes
  OpenProfile.UpdateName(NameEdit.text, NameImgEdit.Text, CustFrontHTMLMemo.Text,
    CustEndHTMLMemo.Text, ShowNameCol.Color, NamesList.ItemIndex);
end;
(**********************************************************************************************)

procedure THTMLform.ActRemoveFromListExecute(Sender: TObject);
var
  index: integer;                       // remove selected files from the input files
begin
  if SrcFilesList.selcount > 0 then
    // work backwards to avoid accessing freed strings
    for index := SrcFilesList.selcount - 1 downto 0 do
      OpenProfile.IOOptions.deleteFile(SrcFileslist.selected.index);
  OpenProfile.IOOptions.SynchFilesList; // update UI
end;
(**********************************************************************************************)

procedure THTMLform.ActPickColExecute(Sender: TObject);
var
  Colindex: integer;                    // a new color is picked
  colLabel: TLabel;
begin
  if (Sender is TbitBtn) then
    begin                               // get the control that requested the
      Colindex := TBitbtn(sender).tag;  // color change (based on the tag field)
      case Colindex of
        TagNameColor: ColLabel := ShowNameCol; // find out which control will be changed
        TagPageColor: ColLabel := ShowBackCol;
        TagTextColor: ColLabel := ShowTextCol;
        TagLinkColor: ColLabel := ShowLinkCol;
        TagVisLinkColor: colLabel := ShowvisLinkCol;
        else
          exit;                         // exit procedure if tag is not recognized
      end;
      Colindex := TBitbtn(sender).tag;  // reload colindex (it's undefined after case)
      ColorDia.Color := ColLabel.Color; // get initial color
      if colorDia.Execute then
        begin
          ColLabel.color := colorDia.Color; // get color picked by user
          if Colindex <> TagNameColor then // names page is updated manually
            begin
              UpdateClass.SettingsChanged := true; // signal changes
              UpdateFromHTMLPage;       // update the HTMLoptions page if needed
            end;
        end;
    end;
end;
(**********************************************************************************************)

procedure THTMLform.ActSaveOptsExecute(Sender: TObject);
begin                                   // save current profile under the current
  OpenProfile.SaveToFile(customIni.CurrProfileName); // profile name
  customini.SaveIniValues;              // also save the MRU list to ini file
  UpdateClass.SettingsChanged := False; // signal that no changes have taken place
end;
(**********************************************************************************************)

procedure THTMLform.ActAboutExecute(Sender: TObject);
var
  FrmAbout: TFrmAbout;                  // create and show the "About" dialog
begin
  Application.createForm(TFrmAbout, FrmAbout);
  FrmAbout.Showmodal;
end;
(**********************************************************************************************)

procedure THTMLform.ActOpenProfileExecute(Sender: TObject);
var
  LastFile: string;                     // Try to load the profile specified in the
begin                                   // openDialog by the user
  LastFile := CustomIni.CurrProfileName; // save current profile name
  OpenDia.InitialDir := ExtractFilePath(CustomIni.FileName); // initialize the Open Dialog
  OpenDia.DefaultExt := CustomIni.defaultExt;
  OpenDia.Filter := 'Configuration files|*' + CustomIni.DefaultExt + '|All files|*.*';
  OpenDia.Options := OpenDia.Options - [ofAllowMultiSelect, ofFileMustExist];
  if OpenDia.Execute then
    if OpenCFGfile(OpenDIa.Filename, LastFile) then // try to load the selected profile file
      begin
        CustomIni.CurrProfileName := OpenDia.FileName;
        CustomIni.SaveIniValues;        // update and save the MRU list
        UpdateClass.SettingsChanged := False; // signal that no changes have taken place
      end;
end;
(**********************************************************************************************)

procedure THTMLform.ActSaveNewOptsExecute(Sender: TObject); // save the current profile under
begin                                   // a new file name
  SaveDia.InitialDir := ExtractFilePath(CustomIni.FileName);
  SaveDia.DefaultExt := CustomIni.defaultExt;
  SaveDia.Filter := 'Configuration files|*' + CustomIni.DefaultExt + '|All files|*.*';
  if SaveDia.execute then
    begin
      if OpenProfile.SaveToFile(SaveDia.fileName) then
        if OpenCFGFile(SaveDia.FileName, Customini.CurrProfileName) then
          begin
            CustomIni.CurrProfileName := SaveDia.FileName; // update and save the MRU
            CustomIni.SaveIniValues;
            UpdateClass.SettingsChanged := false; // signal that no changes have taken place
          end;
    end;
end;
(**********************************************************************************************)

procedure THTMLform.ActConvertExecute(Sender: TObject);
var
  StatusCheck: string;                  // start converting the files listed in the
  laststatus: boolean;                  // SrcFilesListview to HTML
  oldhint: string;
begin
  LastStatus := ActRemoveFromList.Enabled; // save the status of the remove action
  try
    statusbar.Panels[2].text := 'Converting...';
    Screen.Cursor := crAppStart; 
    oldhint := BtnConvert.Hint;         // save the old hint for the convert button
    BtnConvert.Hint := 'Click to stop the ongoing conversion'; // set new hint
    BtnConvert.SetFocus;                // make the convert/stop button default
    btnExit.Enabled := false;           // disable quitting the application
    ActAddToList.enabled := false;      // also diable most other operations
    ActRemoveFromList.Enabled := false;
    PageControl.Pages[1].enabled := false; // disable other pages
    PageControl.Pages[2].enabled := false;
    PageControl.Pages[3].enabled := false;
    BtnConvert.Action := ActStopConvert; // change the Convert button to Stop button
    if not Converter.ConvertFiles(StatusCheck) then // try running the converter
      application.messagebox(pchar(statusCheck), 'Conversion Error', mb_iconstop);
  finally                               // and report back any errors
    btnExit.Enabled := true;
    Pagecontrol.ActivePage := PageControl.Pages[0]; // re-enable diabled options
    PageControl.Pages[1].enabled := true; // and set controls back to their normal state
    PageControl.Pages[2].enabled := true;
    PageControl.Pages[3].enabled := true;
    BtnConvert.Hint := oldHint;
    BtnConvert.Action := ActConvert;
    ActAddToList.enabled := true;
    ActRemoveFromList.Enabled := LastStatus;
    Screen.Cursor := crDefault; 
    BtnAdd.SetFocus;
  end;
end;
(**********************************************************************************************)

procedure THTMLform.ActStopConvertExecute(Sender: TObject);
begin                                   // tell the converter to stop its job now !
  if assigned(Converter) then
     begin
      Converter.stop;
      Self.StatusBar.Panels[2].Text := 'Stoping...';
     end;
end;
(**********************************************************************************************)

procedure THTMLform.ActClearMRUExecute(Sender: TObject);
begin                                   // clear the MRU profile list
  Customini.ClearMRU;
end;
(**********************************************************************************************)

procedure THTMLform.HelpBtnClick(Sender: TObject);
begin
  shellexecute(Application.handle, PChar('open'), pchar(application.HelpFile),nil, nil, sw_show);
end;
(**********************************************************************************************)

end.

